//+------------------------------------------------------------------+
//|                                                Adaptable_RSI.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 clrDeepSkyBlue

extern int                Length = 14;
extern ENUM_MA_METHOD     Method =  1;
extern ENUM_APPLIED_PRICE Price  =  0;
extern double             OverBoughtLevel=70;
extern double             OverSoldLevel=30;

double ARSI[];
double Loss[], Gain[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,ARSI);
   SetIndexBuffer(1,Loss);
   SetIndexBuffer(2,Gain);

   SetLevelValue(0, 50.);
   SetLevelValue(1, OverBoughtLevel);
   SetLevelValue(2, OverSoldLevel);
   SetLevelValue(3, 0.);
   SetLevelValue(4, 100.);
   IndicatorShortName("Adaptable RSI oscillator ("+Length+")");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int pos=limit; pos>=0; pos--)
   {
      double Pr0=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos);
      double Pr1=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos+1);
      double diff=Pr0-Pr1;
      if (diff>0.)
            { Loss[pos]=0; Gain[pos]=diff;  }
      else  { Loss[pos]=-diff; Gain[pos]=0; }
   } 
   for(pos=limit; pos>=0; pos--)
   {
      double MA_Loss=iMAOnArray(Loss, 0, Length, 0, Method, pos);
      double MA_Gain=iMAOnArray(Gain, 0, Length, 0, Method, pos);
      if (MA_Loss!=0.)
            ARSI[pos]=100.-100./(1.+MA_Gain/MA_Loss);
      else  ARSI[pos]=0;
   }
   return(0);
}